/***************************************************************************
                          kmailcvt.cpp  -  description
                             -------------------
    begin                : Thu Jun 29 21:37:17 CEST 2000
    copyright            : (C) 2000 by Hans Dijkema
    email                : kmailcvt@hum.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "kmailcvt.h"

//////////////////////////////////////////////////////////////////////////////
//
// Add filters here
//
//////////////////////////////////////////////////////////////////////////////

#include "filter_oe4.hxx"
#include "filter_oe5.hxx"
#include "filter_pab.hxx"

void Kmailcvt::doFilters(void)
{
  imports->add(new filter_pab);
  imports->add(new filter_oe5);
  imports->add(new filter_oe4);
}

//////////////////////////////////////////////////////////////////////////////
//
// Code not to be touched
//
//////////////////////////////////////////////////////////////////////////////

Kmailcvt::Kmailcvt(QWidget *parent, const char *name) : QWidget(parent, name)
{
  info=new filterInfo(this);

  imports=new filters(info,this);
  doFilters();
  imports->adjustSize();
  imports->move(10,10);

  import=new QPushButton("&Import",this);
  import->adjustSize();
  import->move(imports->width()+imports->x()+10,10);

  quit=new QPushButton("&Quit",this);
  quit->resize(import->width(),import->height());
  quit->move(import->x()+import->width()+10,10);

  connect(import,SIGNAL(clicked()),SLOT(startFilter()));
  connect(quit,SIGNAL(clicked()),SLOT(Quit()));

  resize(quit->x()+quit->width()+10,height());

  info->adjustSize();

  setCaption("Kmail Import Filters " KMAILCVT_VERSION);
}

Kmailcvt::~Kmailcvt()
{
  delete imports;
  delete import;
  delete quit;
}


void Kmailcvt::startFilter()
{
  import->setEnabled(false);
  imports->setEnabled(false);
  quit->setEnabled(false);
  imports->import();
  imports->setEnabled(true);
  import->setEnabled(true);
  quit->setEnabled(true);
}

void Kmailcvt::Quit()
{
  close();
}